{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

UNIT BotSkinDefines;

INTERFACE

uses classes;

type

(*TBotSkinRec = record
    UTName:string; {TSkMSkins.Warr}
    Desc:string;   {Arena Warrior}
    IsTeamSkinnable:boolean;
  end;



TBotSkinData = class(TObject)
    Faces:TStringList;
    FaceDescs:TStringList;
    UTName:string; {TSkMSkins.Warr}
    Desc:string;   {Arena Warrior}
    IsTeamSkinnable:boolean;
{  private
    InternalDetails: TBotSkinRec;   }
  public
    constructor Create;
    destructor Destroy; override;
  {  property Details: TBotSkinRec read InternalDetails write InternalDetails; default;}

  end;

TBotModelRec = record
    BotClass:string;        {Botpack.TSkaarjBot}
    SkinPackPrefix:string;  {TSkM}
    IsMale:byte; {0 for female, 1 for male, 2 for Xan}
    HasFaces:boolean;
    Desc:string;
  end;

TBotModelData = class(TObject)
    BotClass:string;        {Botpack.TSkaarjBot}
    SkinPackPrefix:string;  {TSkM}
    IsMale:byte; {0 for female, 1 for male, 2 for Xan}
    HasFaces:boolean;
    Desc:string;
  private
    PtrList:TList;
    {InternalDetails:TBotModelRec;}
  protected
    function GetCount:Integer;
    function GetData(Index:Integer):TBotSkinData;
    procedure SetData(Index:Integer;R:TBotSkinData);
  public
    constructor Create;
    destructor Destroy; override;
    procedure AppendSkin(R:TBotSkinData);
    procedure DeleteAndFreeSkin(index:integer);
    procedure ClearSkins;
    property SkinsCount: Integer read GetCount;
    property Skins[Index:Integer]:TBotSkinData read GetData write SetData;
  {  property Details:TBotModelRec read InternalDetails write InternalDetails; default;}
  end;      *)

TBotVoicesList = class(TObject)
  public
  VNames:TStringList;
  VClasses:TStringList;
  constructor Create;
  destructor Destroy; override;
  end;

TBotVoiceData = record
    PackAndClass:string; {botpack.voicemale2}
    Desc:string;
    IsMale:byte; {see model for details}
    end;

(*TBotModelsList = class(TObject)
       private
              PtrList:TList;
       protected
              function GetCount:Integer;
              function GetData(Index:Integer):TBotModelData;
              procedure SetData(Index:Integer;R:TBotModelData);
       public
              constructor Create;
              destructor Destroy; override;
              procedure Append(R:TBotModelData);
              procedure DeleteAndFreeModel(index:integer);
              procedure Clear;
              property Count: Integer read GetCount;
              property Models[Index:Integer]:TBotModelData read GetData write SetData; default;
       end;
                        *)

IMPLEMENTATION
(*{MODELS LIST}
{protected functions}
function TBotModelslist.GetCount:Integer;
Begin
  Result:=PtrList.Count;
End;

function TBotModelsList.GetData(Index:Integer):TBotModelData;
var P:^TBotModelData;
Begin
  P:=PtrList.Items[Index];
  Result:=P^;
End;

procedure TBotModelsList.SetData(Index:Integer;R:TBotModelData);
var Pi:^TBotModelData;
Begin
  Pi:=PtrList.Items[Index];
  Pi^:=R;
End;
{public functions}
constructor TBotModelsList.Create;
Begin
PtrList:=TList.Create;
End;

destructor TBotModelsList.Destroy;
Begin
PtrList.Free;
inherited Destroy;
End;

procedure TBotModelsList.Append(R:TBotModelData);
var Pi:^TBotModelData;
Begin
  New(Pi);
  Pi^:=R;
  PtrList.Add(Pi);
End;

procedure TBotModelsList.DeleteAndFreeModel(index:integer);
Begin
  Self.Models[index].Free;
  Self.PtrList.Delete(index);
  PtrList.Capacity:=PtrList.Count;
End;

procedure TBotModelsList.Clear;
var i:integer;
    p:^TBotModelData;
Begin
  for i:=0 to PtrList.Count-1 do begin
    p:=PtrList.Items[i];
    if (p<>nil) then begin p^.Free; Dispose(p); end;
    end;
  PtrList.Clear;
End;


 {MODEL}
{protected functions}
function TBotModelData.GetCount:Integer;
Begin
  Result:=PtrList.Count;
End;

function TBotModelData.GetData(Index:Integer):TBotSkinData;
var P:^TBotSkinData;
Begin
  P:=PtrList.Items[Index];
  Result:=P^;
End;

procedure TBotModelData.SetData(Index:Integer;R:TBotSkinData);
var Pi:^TBotSkinData;
Begin
  Pi:=PtrList.Items[Index];
  Pi^:=R;
End;
{public functions}
constructor TBotModelData.Create;
Begin
PtrList:=TList.Create;
End;

destructor TBotModelData.Destroy;
Begin
Self.ClearSkins;
PtrList.Free;
inherited Destroy;
End;

procedure TBotModelData.AppendSkin(R:TBotSkinData);
var Pi:^TBotSkinData;
Begin
  New(Pi);
  Pi^:=R;
  PtrList.Add(Pi);
End;

procedure TBotModelData.DeleteAndFreeSkin(index:integer);
Begin
  Self.Skins[index].Free;
  Self.PtrList.Delete(index);
  PtrList.Capacity:=PtrList.Count;
End;

procedure TBotModelData.ClearSkins;
var i:integer;
    p:^TBotSkinData;
Begin
  for i:=0 to PtrList.Count-1 do begin
    p:=PtrList.Items[i];
    if (p<>nil) then begin p^.Free; Dispose(p); end;
    end;
  PtrList.Clear;
End;

constructor TBotSkinData.Create;
begin
Self.Faces:=TStringList.Create;
Self.FaceDescs:=TStringList.Create;
end;

destructor TBotSkinData.Destroy;
begin
Faces.Free;
FaceDescs.Free;
end;                   *)

constructor TBotVoicesList.Create;
Begin
  Vnames:=TStringList.Create;
  Vclasses:=TStringList.Create;
End;

destructor TBotVoicesList.Destroy;
Begin
  Vnames.Free;
  Vclasses.Free;
End;

END.