{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit Knowledge;
interface

uses {BotSkinDefines,}Classes,SysUtils,Inifiles,Forms,Dialogs,UTSharedUtils1,
TModDetailsDefine,TBotModelDefine,TBotSkinDefine,TBotVoiceDefine,
TBigModFileDefine;

const
{obsolete
ModelsHeader='UTSC-Data-Format-2-Model';
SkinsHeader='UTSC-Data-Format-2-Skin';
VoiceHeader='UTSC-Data-Format-2-Voice';      }

{the new ones}
hHeader='UT_Server_Config_Header';
vFormat='EarliestCompatibleUTSC';
vWriter='CreatedByUTSC';
vDatafileCompilerName='DatafileCompilerName';
OldestVersionWhichCanReadMyFileFormat=110;
MyVersion=210;
vNumModels='NumModels';
vNumSkins='NumSkins';
vNumVoices='NumVoices';

hMod='Mod';
vModName='Name';
vAuthor='Author';
vEmail='E-mail';
vWWW='WWW';
vOtherContact='OtherContact';
vModDesc='DescriptionOfMod';
vTypeHeader='ModType';

hSPs='ServerPackages';
vNumSPs='NumSPs';
vSPPrefix='SP-';

hModelPrefix='Model-';
vModelBotClass='BotClass';
vModelMesh='MeshName';
vModelDesc='Desc';
vModelIsMale='VoiceType';
vModelHasFaces='HasFaces';

hSkinPrefix='Skin-';
vSkinName='Skin';
vSkinDesc='Desc';
vSkinNumFaces='NumFaces';
vFacePrefix='Face-';
vFaceDescPrefix='FaceDesc-';
vSkinTeams='IsTeamSkinnable';

hVoicePrefix='Voice-';
vVoiceClass='VoiceClass';
vVoiceDesc='Desc';
vVoiceIsMale='VoiceType';

var MasterModelsList:TBotModelList;
    MasterMaleVoiceList,MasterFemaleVoiceList,MasterXanVoiceList:TBotVoiceList;
    MasterModsList:TModDetailsList;

procedure LoadMasterList;


implementation

uses UTServerConfigGlobal,SvPackFiles;

var SkinsCache:TBotSkinList;


{procedure showstuff;
var i,j:integer;
begin
for i:=0 to MasterModelsList.Count-1 do
  begin
    form1.Memo1.Lines.Append('Model '+MasterModelsList.Models[i].Desc);
    for j:=0 to MasterModelsList.Models[i].skinscount-1 do begin
      form1.Memo1.Lines.Append('--Skin '+MasterModelsList.Models[i].Skins[j].desc);
      form1.Memo1.Lines.Append('----Faces '+MasterModelsList.Models[i].Skins[j].FaceDescs.CommaText);
      end;  end;
form1.Show;
end;{showstuff}

procedure LoadIndividualKnowledgeFile(Filename,SysIni:string);
var NewMdl:TBotModel;
    NewSkin:TBotSkin;
    NewMod:TModDetails;
    NewVoice:TBotVoice;
    FileReader:TIniFile;
    i,j,NumFaces,NumObjects:integer;
    s,t:string;
Begin
  FileReader:=TIniFile.Create(filename);
  if (FileReader.ReadInteger(hHeader,vFormat,9999)<=MyVersion) then begin
    {try to load the mod}
    NewMod:=TModDetails.Create;
    NewMod.UtscDatafile:=Filename;
    NewMod.DatafileCompilerName:=FileReader.ReadString(hHeader,vDatafileCompilerName,'');
    NewMod.Name:=FileReader.ReadString(hMod,vModName,'(Unknown)');
    NewMod.Author:=FileReader.ReadString(hMod,vAuthor,'(Anonymous)');
    NewMod.Email:=FileReader.ReadString(hMod,vEmail,'');
    NewMod.WWW:=FileReader.ReadString(hMod,vWWW,'');
    NewMod.OtherContact:=FileReader.ReadString(hMod,vOtherContact,'');
    NewMod.Description:=FileReader.ReadString(hMod,vModDesc,'');
    NewMod.IsInstalled:=TRUE; {for now}
    NewMod.TypeHeader:=FileReader.ReadString(hMod,vTypeHeader,'');
    {read the serverpackages required}
    NumObjects:=FileReader.ReadInteger(hSPs,vNumSPs,0);
    if (NumObjects>0) then
      for i:=1 to NumObjects do begin
        s:=FileReader.ReadString(hSPs,vSPPrefix+IntToStr(i),'');
        if (s<>'') then NewMod.ServerPackages.Append(s);
        if (s<>'') AND (NOT PackageExists(s,SysIni)) then NewMod.IsInstalled:=FALSE;
      end;{for}

{==============================================================================}
    {a possible future DAT update: if there's a dat entry with the same name, kill it!}
    {insert some code here}

    {finished with the mod, so: }
    MasterModsList.Append(NewMod);

    {load up the models next}
    NumObjects:=FileReader.ReadInteger(hHeader,vNumModels,0);
    if (NumObjects>0) then
      for i:=1 to NumObjects do begin
        s:=hModelPrefix+IntToStr(i);
        NewMdl:=TBotModel.Create;
        NewMdl.BotClass:=FileReader.ReadString(s,vModelBotClass,'');
        NewMdl.SkinPackPrefix:=FileReader.ReadString(s,vModelMesh,'');
        NewMdl.HasFaces:=(FileReader.ReadInteger(s,vModelHasFaces,1)=1);
        NewMdl.IsMale:=FileReader.ReadInteger(s,vModelIsMale,1);
        NewMdl.Desc:=FileReader.ReadString(s,vModelDesc,NewMdl.BotClass);
        if PackageExists(ExtractPackageName(NewMdl.BotClass),SysIni) then
        MasterModelsList.Append(NewMdl);
      end;{for i}
    {now try loading skins, these go in a cache for now}
    NumObjects:=FileReader.ReadInteger(hHeader,vNumSkins,0);
    if (NumObjects>0) then
      for i:=1 to NumObjects do begin
        s:=hSkinPrefix+IntToStr(i);
        NewSkin:=TBotSkin.Create;
        NewSkin.UTName:=FileReader.ReadString(s,vSkinName,'');
        NewSkin.IsTeamSkinnable:=(FileReader.ReadInteger(s,vSkinTeams,1)=1);
        NewSkin.Desc:=FileReader.ReadString(s,vSkinDesc,NewSkin.UTName);

        NumFaces:=FileReader.ReadInteger(s,vSkinNumFaces,0);
        if (NumFaces>0) then
          for j:=1 to NumFaces do begin
            t:=FileReader.ReadString(s,vFacePrefix+IntToStr(j),'');
            if (t<>'') then begin
              NewSkin.Faces.Append(t);
              NewSkin.FaceDescs.Append(FileReader.ReadString(s,vFaceDescPrefix+IntToStr(j),t));
            end;{if}
          end;{for j}
        if PackageExists(ExtractPackageName(NewSkin.UTName),SysIni) then
        SkinsCache.Append(NewSkin);
      end;{for i}

    {finally, do voices}
    NumObjects:=FileReader.ReadInteger(hHeader,vNumVoices,0);
    if (NumObjects>0) then
      for i:=1 to NumObjects do begin
        s:=hVoicePrefix+IntToStr(i);
        NewVoice:=TBotVoice.Create;
        NewVoice.VoiceClass:=FileReader.ReadString(s,vVoiceClass,'');
        NewVoice.VoiceType:=FileReader.ReadInteger(s,vVoiceIsMale,1);
        NewVoice.Desc:=FileReader.ReadString(s,vVoiceDesc,NewVoice.VoiceClass);
        if PackageExists(ExtractPackageName(NewVoice.VoiceClass),SysIni) then begin
        if (NewVoice.VoiceType=voxMale) then begin
          MasterMaleVoiceList.Append(NewVoice);
        end else if (NewVoice.VoiceType=voxFemale) then begin
          MasterFemaleVoiceList.Append(NewVoice);
        end else begin
          MasterXanVoiceList.Append(NewVoice);
        end;{else}end;{if}
      end;{for i}
  end;{if}
End;

function ReadTerminatedString(Stream:TStream;Terminator:char):string;
var c:char;
Begin
Result:='';
try
  Stream.Read(c,1);
except
  on EReadError do c:=Terminator;
end;{try}
while c<>Terminator do
  begin
      Result:=Result+c;
    try
      Stream.Read(c,1);
    except
      on EReadError do c:=Terminator;
    end;{try}
  end;{while}
End;

procedure LoadMasterList;
var
    DataPath,Filename,s:string;
    errCode,i,j:integer;
    Details:TSearchRec;
    SysIni:string;
    ThisMod:TBigModFile;
    Sigma:TFileStream;
    newVoice:TBotVoice; newModel:tBotModel; newSkin:TBotSkin;  newMod:TModDetails;
Begin
MasterModelsList.Clear;
MasterMaleVoiceList.Clear;
MasterFemaleVoiceList.Clear;
MasterXanVoiceList.Clear;
MasterModsList.Clear;
ThisMod:=NIL;

DataPath:=ExtractFileDir(Application.ExeName);  {e.g. 'c:\program files\utsc'}

SkinsCache:=TBotSkinList.Create;

SysIni:=global.UTSysIni;
try
{load the big UTSC210.dat file if it exists}
{==============================================================================}
if FileExists(DataPath+'\UTSC210.dat') then begin
Sigma:=TFileStream.Create(DataPath+'\UTSC210.dat',fmOpenRead OR fmShareDenyWrite);
try
s:=ReadTerminatedString(Sigma,#0);
if s<>'pseudorandom.co.uk_UTSC_Binary_v210' then raise EStreamError.Create('File corrupted');
ReadTerminatedString(Sigma,#0); {and scrap the result}
  ThisMod:=TBigModFile.CreateAndRead(Sigma);
  while ThisMod.IExist do
  begin
    NewMod:=ThisMod.ModDetails;
    NewMod.UtscDatafile:='';
    NewMod.IsInstalled:=TRUE;
    for errCode:=1 to Newmod.ServerPackages.Count-1 do begin
        if NOT PackageExists(NewMod.ServerPackages[errCode],SysIni) then NewMod.IsInstalled:=FALSE;
      end;{for}
    MasterModsList.Append(NewMod.Clone);
    for errcode:=0 to ThisMod.Models.Count-1 do begin
      NewModel:=ThisMod.Models[errcode];
      if PackageExists(ExtractPackageName(NewModel.BotClass),SysIni) then
        MasterModelsList.Append(NewModel.Clone);
    end;{for models}
    for errcode:=0 to ThisMod.Skins.Count-1 do begin
      NewSkin:=ThisMod.Skins[errcode];
      if PackageExists(ExtractPackageName(NewSkin.UTName),SysIni) then
      SkinsCache.Append(NewSkin.Clone);
    end;{for skins}
    for errcode:=0 to ThisMod.Voices.Count-1 do begin
      NewVoice:=ThisMod.Voices[errcode];
      if PackageExists(ExtractPackageName(NewVoice.VoiceClass),SysIni) then begin
        if (NewVoice.VoiceType=voxMale) then begin
          MasterMaleVoiceList.Append(NewVoice.Clone);
        end else if (NewVoice.VoiceType=voxFemale) then begin
          MasterFemaleVoiceList.Append(NewVoice.Clone);
        end else begin
          MasterXanVoiceList.Append(NewVoice.Clone);
        end;{else}end;{if}
    end;{for voices}
    ThisMod.Free;
    ThisMod:=TBigModFile.CreateAndRead(Sigma);
  end;{while}
finally
Sigma.Free;
if assigned(ThisMod) then ThisMod.Free;
end;{try}
end;{if exist USTC.dat}
except
on EStreamError do ShowMessage('Error opening UTSC210.DAT, check no other apps have it open');
end;{try}

{load *.UTSC.INI first - these are the built-in ones}

errcode:=FindFirst(DataPath+'\*.utsc.ini',faAnyFile,Details);
while (errcode=0) do begin
  Filename:=DataPath+'\'+Details.FindData.cFileName;
  LoadIndividualKnowledgeFile(Filename,SysIni);
  errcode:=FindNext(Details);
end;{while}
FindClose(Details);

errcode:=FindFirst(DataPath+'\*.utsc.txt',faAnyFile,Details);
while (errcode=0) do begin
  Filename:=DataPath+'\'+Details.FindData.cFileName;
  LoadIndividualKnowledgeFile(Filename,SysIni);
  errcode:=FindNext(Details);
end;{while}
FindClose(Details);

{copy pointers from cache}

for i:=0 to SkinsCache.Count-1 do
  for j:=0 to MasterModelsList.Count-1 do
    if StartsWith(UpperCase(SkinsCache[i].UTName),UpperCase(MasterModelsList[j].SkinPackPrefix))
      then MasterModelsList[j].Skins.Append(SkinsCache[i].Clone);

{showstuff;      }


End;

initialization
mastermodelslist:=tbotmodellist.create;
mastermalevoicelist:=tbotvoicelist.create;
masterfemalevoicelist:=tbotvoicelist.create;
masterxanvoicelist:=tbotvoicelist.create;
skinscache:=tbotskinlist.create;
mastermodslist:=tmoddetailslist.create;

finalization
mastermodelslist.Free;
mastermalevoicelist.Free;
masterfemalevoicelist.Free;
masterxanvoicelist.Free;
skinscache.Free;
mastermodslist.Free;

end.
