{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

UNIT ModelsLoader;

INTERFACE

uses Knowledge,classes,TBotModelDefine,TBotSkinDefine,TBotVoiceDefine;

procedure FillModelListBoxFromMasterList(Tau:TStrings);
procedure FillSkinListBoxFromMasterList(SelModel:integer;CustomModel:integer;Tau:TStrings);
procedure FillFaceListBoxFromMasterList(SelModel:integer;SelSkin:integer;CustomSkin:integer;Tau:TStrings);
procedure FillVoiceListBoxFromMasterList(voicetype:byte;Tau:TStrings);

var CurrentMasterVoiceList:TBotVoiceList;

IMPLEMENTATION

procedure FillModelListBoxFromMasterList(Tau:TStrings);
var i:integer;
Begin
  Tau.Clear;
  if (MasterModelsList.Count>0) then
    for i:=0 to MasterModelsList.Count-1 do
      Tau.Append(MasterModelsList[i].Desc);
  Tau.Append('Custom...');
End;

procedure FillSkinListBoxFromMasterList(SelModel:integer;CustomModel:integer;Tau:TStrings);
var i:integer;
Begin
  Tau.Clear;
  if (SelModel<>CustomModel) then
    if (MasterModelsList[SelModel].Skins.Count>0) then
      for i:=0 to MasterModelsList[SelModel].Skins.Count-1 do
        Tau.Append(MasterModelsList[SelModel].Skins[i].Desc);
  Tau.Append('Custom...');
End;

procedure FillFaceListBoxFromMasterList(SelModel:integer;SelSkin:integer;CustomSkin:integer;Tau:TStrings);
var i:integer;
Begin
  Tau.Clear;
  if (SelSkin<>CustomSkin) then
  if MasterModelsList[SelModel].HasFaces then begin
    if (MasterModelsList[SelModel].Skins[SelSkin].Faces.Count>0) then
      for i:=0 to MasterModelsList[SelModel].Skins[SelSkin].Faces.Count-1 do
        Tau.Append(MasterModelsList[SelModel].Skins[SelSkin].FaceDescs[i]);
  end;{if hasfaces}
  Tau.Append('Custom...');
End;

procedure FillVoiceListBoxFromMasterList(voicetype:byte;Tau:TStrings);
var i:integer;
Begin
Tau.Clear;

  case voicetype of
    0:CurrentMasterVoiceList:=MasterFemaleVoiceList.Clone;
    1:CurrentMasterVoiceList:=MasterMaleVoiceList.Clone;
    2:CurrentMasterVoiceList:=MasterXanVoiceList.Clone;
    else begin CurrentMasterVoiceList:=MasterMaleVoiceList.Clone{+
                   MasterFemaleVoiceList.VClasses.Text+
                   MasterXanVoiceList.VClasses.Text};
  CurrentMasterVoiceList:=MasterMaleVoiceList.Clone{+
                   MasterFemaleVoiceList.VNames.Text+
                   MasterXanVoiceList.VNames.Text};
      end;{else}
    end;{case}  



if (CurrentMasterVoiceList.Count>0) then
    for i:=0 to CurrentMasterVoiceList.Count-1 do
      Tau.Append(CurrentMasterVoiceList[i].Desc);
Tau.Append('Custom...');

End;

INITIALIZATION
CurrentMasterVoiceList:=TBotVoiceList.Create;

FINALIZATION
CurrentMasterVoiceList.Free;

END.
