{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit T313ListDefine;

interface

uses Classes,T313ObjectDefine;

type

T313List=class(T313Object)
  protected
    iPointers:TList;
    function GetCount:Integer;
    function GetData(Index:Integer):T313Object;
    procedure SetData(Index:Integer;o:T313Object);
  public
    constructor Create;
    destructor Destroy; override;
    function Clone:T313List;
    procedure Append(o:T313Object);
    procedure Delete(index:integer);
    procedure Clear;
    property Count: Integer read GetCount;
    property Items[Index:Integer]:T313Object read GetData write SetData; default;
  end;

implementation

function T313List.GetCount:Integer;
Begin
  Result:=iPointers.Count;
End;

function T313List.GetData(index:integer):T313Object;
Begin
  Result:=T313Object(iPointers[index]^);
End;

{procedure T313GenericList.SetData(index:integer;o:T313Object);
var x:P313Object;
Begin
  T313Object(iPointers[index]^).Free;
  x:=@o;
  iPointers[index]:=x;
End;}

procedure T313List.SetData(index:integer;o:T313Object);
Begin
  T313Object(iPointers[index]^).Free;
  iPointers[index]:=@o;
End;


constructor T313List.Create;
Begin
  iPointers:=TList.Create;
End;

destructor T313List.Destroy;
Begin
  Self.Clear;
  iPointers.Free;
  Inherited Destroy;
End;

procedure T313List.Clear;
var i:integer;
Begin
if Self.Count>0 then
  for i:=Self.Count-1 downto 0 do
    Self.Delete(i);
End;

procedure T313List.Delete(index:integer);
Begin
  TObject(iPointers.Items[index]^).Free;
  iPointers.Delete(index);
End;

{function T313GenericList.Detach(index:integer):P313Object;
var i:integer;
Begin
  Result:=P313Object(iPointers.Items[index]);
  iPointers.Delete(index);
End; }

procedure T313List.Append(o:T313Object);
var p:P313Object;
Begin
  New(p);
  p^:=o;
  iPointers.Add(p);
End;

function T313List.Clone:T313List;
var i:integer;
Begin
Result:=T313List.Create;
if Self.Count>0 then
  for i:=0 to Self.Count-1 do
    Result.Append(Self[i].Clone);
End;

end.
