{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit TBigKegOBotsDefine;
{==============================================================================
       BIG KEG O'BOTS
==============================================================================}

interface

uses Classes,TBotDefine,SysUtils;

type

TBigKegOBots = class(TObject)
       private
              PtrList:TList;
       protected
              function GetCount:Integer;
              function GetData(Index:Integer):TBot;
              procedure SetData(Index:Integer;R:TBot);
       public
              procedure Init;
              destructor Destroy; override;
              procedure Append(R:TBot);
              procedure Insert(Index:Integer;R:TBot);
              procedure Delete(Index:Integer);
              procedure Clear;
              procedure Sort;
              property Count: Integer read GetCount;
              property Data[Index:Integer]:TBot read GetData write SetData; default;
       end;{class}

function SortBotNames(Item1, Item2: Pointer):Integer;

implementation

type

PKegRecord=^TBot;

{protected functions}
function TBigKegOBots.GetCount:Integer;
Begin
  Result:=PtrList.Count;
End;

function TBigKegOBots.GetData(Index:Integer):TBot;
var P:PKegRecord;
Begin
  P:=PtrList.Items[Index];
  Result:=P^;
End;

procedure TBigKegOBots.SetData(Index:Integer;R:TBot);
var Pi:PKegRecord;
Begin
  Pi:=PtrList.Items[Index];
  Pi^:=R;
End;
{public functions}
procedure TBigKegOBots.Init;
Begin
PtrList:=TList.Create;
End;

destructor TBigKegOBots.Destroy;
Begin
PtrList.Free;
inherited Destroy;
End;

procedure TBigKegOBots.Append(R:TBot);
var Pi:PKegRecord;
Begin
  New(Pi);
  Pi^:=R;
  PtrList.Add(Pi);
End;

procedure TBigKegOBots.Insert(Index:Integer;R:TBot);
var Pi:PKegRecord;
Begin
  New(Pi);
  Pi^:=R;
  PtrList.Insert(Index,Pi);
End;

procedure TBigKegOBots.Delete(Index:Integer);
var Pi:PKegRecord;
Begin
  Pi:=PtrList.Items[Index];
  PtrList.Delete(Index);
  PtrList.Capacity:=PtrList.Count;
  Dispose(Pi);
End;

procedure TBigKegOBots.Sort;
Begin
  PtrList.Sort(SortBotNames);
End;

procedure TBigKegOBots.Clear;
var i:integer;
    p:pointer;
Begin
  for i:=0 to PtrList.Count-1 do begin
    p:=PtrList.Items[i];
    if (p<>nil) then Dispose(p);
    end;
  PtrList.Clear;
End;

function SortBotNames(Item1, Item2: Pointer):Integer;
var a,b:string;
Begin
    a:=uppercase(TBot(Item1^).Name);
    b:=uppercase(TBot(Item2^).Name);
    if (a<b) then result:=-1
    else if (a=b) then result:=0
    else result:=1;
End;

END.
