{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

UNIT TBotVoiceDefine;

INTERFACE

Uses T313ObjectDefine,Classes,T313ListDefine;

Const
  voxXan=2;
  voxMale=1;
  voxFemale=0;

Type

TUnrealTournVoiceType = byte;

TBotVoice=class(T313Object)
    Desc:string;
    VoiceClass:string;
    VoiceType:TUnrealTournVoiceType;
    function Clone:TBotVoice;
    end;{type}

TBotVoiceList = class(T313List)
  protected
    function GetData(Index:Integer):TBotVoice;
    procedure SetData(index:integer;o:TBotVoice);
  public
    property Items[Index:Integer]:TBotVoice read GetData write SetData; default;
    function Clone:TBotVoiceList;
  end;

IMPLEMENTATION

function TBotVoice.Clone:TBotVoice;
Begin
  Result:=TBotVoice.Create;
  Result.Desc:=Self.Desc;
  Result.VoiceClass:=Self.VoiceClass;
  Result.VoiceType:=Self.VoiceType;
End;

function TBotVoiceList.GetData(index:integer):TBotVoice;
Begin
  Result:=TBotVoice(iPointers[index]^);
End;

procedure TBotVoiceList.SetData(index:integer;o:TBotVoice);
Begin
  TBotVoice(iPointers[index]^).Free;
  iPointers[index]:=@o;
End;


function TBotVoiceList.Clone:TBotVoiceList;
var i:integer;
Begin
Result:=TBotVoiceList.Create;
if Self.Count>0 then
  for i:=0 to Self.Count-1 do
    Result.Append(Self.Items[i].Clone);
End;

END.
