{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit SvPack;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Menus, checklst, Knowledge, ExtCtrls;

type
  TSvPackForm = class(TForm)
    FileOpenDialog: TOpenDialog;
    MainMenu1: TMainMenu;
    Packages: TMenuItem;
    UnrealTournamentbase1: TMenuItem;
    EpicBonusPack1: TMenuItem;
    N1: TMenuItem;
    Addpackagefromfile1: TMenuItem;
    N2: TMenuItem;
    Removeselectedpackages1: TMenuItem;
    Removepackagesforwhichthefiledoesntexist1: TMenuItem;
    Advanced1: TMenuItem;
    LoadINIfile1: TMenuItem;
    WritetoINIfile1: TMenuItem;
    N3: TMenuItem;
    Help1: TMenuItem;
    ServerPackagesEditor1: TMenuItem;
    N4: TMenuItem;
    Contents1: TMenuItem;
    About1: TMenuItem;
    ServerPackagesPanel: TPanel;
    PackList: TListBox;
    RemSelBtn: TBitBtn;
    ClearListBtn: TBitBtn;
    RemNonExistBtn: TBitBtn;
    Label2: TLabel;
    RightSideScrollbox: TScrollBox;
    AddModGroupbox: TGroupBox;
    CheckListBox1: TCheckListBox;
    ShowHeaderCB: TCheckBox;
    OnlyExistingCB: TCheckBox;
    AddTickedModsBtn: TBitBtn;
    GroupBox5: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    AuthorLabel: TLabel;
    ModTitleLabel: TLabel;
    Label7: TLabel;
    OtherContactLabel: TLabel;
    Description: TLabel;
    Label8: TLabel;
    DescriptionMemo: TMemo;
    ListBox1: TListBox;
    EditDatafileBtn: TBitBtn;
    CreateAnotherDatafileBtn: TBitBtn;
    BitBtn1: TBitBtn;
    LoadBtn: TBitBtn;
    SaveBtn: TBitBtn;
    ThisDatafileByLabel: TLabel;
    AddBonusPackBtn: TBitBtn;
    AddUTPkgsBtn: TBitBtn;
    Label1: TLabel;
    StatusLabel: TLabel;
    InDataStoreLabel: TLabel;
    EmailLabel: TLabel;
    WWWLabel: TLabel;
    procedure AddUTPkgsBtnClick(Sender: TObject);
    procedure AddPack(packagename:string);
    procedure AddBonusPackBtnClick(Sender: TObject);
    procedure AddModBtnClick(Sender: TObject);
    procedure AddPackFile(PathAndFilename:string);
  {  procedure AddSkinBtnClick(Sender: TObject);
    procedure AddSoundBtnClick(Sender: TObject);         }
    procedure RemNonExistBtnClick(Sender: TObject);
    procedure LoadBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure RemSelBtnClick(Sender: TObject);
    procedure Returntomenu1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckListBox1Click(Sender: TObject);
    procedure CheckListBox1ClickCheck(Sender: TObject);
    procedure UpdateChecklist(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure EditDatafileBtnClick(Sender: TObject);
    procedure CreateAnotherDatafileBtnClick(Sender: TObject);
    procedure AddTickedModsBtnClick(Sender: TObject);
    procedure ServerPackagesEditor1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure ClearListBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SvPackForm: TSvPackForm;

implementation
uses SvPackFiles,UTServerConfigGlobal,UTSharedUtils1,{ModPresetBrowser,}
TModDetailsDefine,about,MainMenu,
  DatafileMaker,SvPack_Filter;

{$R *.DFM}

procedure TSvPackForm.AddUTPkgsBtnClick(Sender: TObject);
begin
  {add compulsory UT packages, needed to support normal bots and players}
  AddPack('BotPack');
  AddPack('SoldierSkins');
  AddPack('SGirlSkins');
  AddPack('CommandoSkins');
  AddPack('FCommandoSkins');
  AddPack('BossSkins');
end;

procedure TSvPackForm.AddPack(packagename:string);
Begin
  {if the pack is already there, don't bother adding it, UT won't like it}
  if Pos(uppercase(packagename),uppercase(PackList.Items.Text))=0
  then PackList.Items.Append(packagename);
End;

procedure TSvPackForm.AddBonusPackBtnClick(Sender: TObject);
{add the Bonus Pack}
begin
  {add the models}
  AddPack('MultiMesh');
  AddPack('EpicCustomModels');
  {don't forget the skins. I did when setting up a LAN server, and it made
  several players completely invisible}
  AddPack('TSkMSkins');
  AddPack('TNaliMeshSkins');
  AddPack('TCowMeshSkins');
  {presumably we also want the Relics mutator}
  AddPack('Relics');
  AddPack('RelicsBindings');
  {maps don't need server packages, so ignore them}
end;

procedure TSvPackForm.AddModBtnClick(Sender: TObject);
begin
FileOpenDialog.InitialDir:=global.UTBase+'\System';
FileOpenDialog.Filter:='All UT mods (*.u,*.utx,*.uax)|*.u;*.utx;*.uax';
if FileOpenDialog.Execute then AddPackFile(FileOpenDialog.FileName);
end;

procedure TSvPackForm.AddPackFile(PathAndFilename:string);
Begin
AddPack(                    {extract just the package name - a bit long}
Copy(ExtractFileName(PathAndFileName),1,
       Length(ExtractFileName(PathAndFileName))
       -Length(ExtractFileExt(PathAndFileName))
     )
);
End;

{procedure TSvPackForm.AddSkinBtnClick(Sender: TObject);
begin
FileOpenDialog.InitialDir:=global.UTBase+'\Textures';
FileOpenDialog.Filter:='UT skins (*skins*.utx)|*skins*.utx|All UT textures|*.utx';
if FileOpenDialog.Execute then AddPackFile(FileOpenDialog.FileName);
end;

procedure TSvPackForm.AddSoundBtnClick(Sender: TObject);
begin
FileOpenDialog.InitialDir:=global.UTBase+'\System';
FileOpenDialog.Filter:='UT voice packages (*.u, *.uax)|*.u;*.uax';
if FileOpenDialog.Execute then AddPackFile(FileOpenDialog.FileName);
end;}

procedure TSvPackForm.RemNonExistBtnClick(Sender: TObject);
var f:string;
begin
f:=Global.UTSysIni;
  if FileExists(f)
    then begin
      VerifyThatPackagesExist(PackList.Items,f);
    end;{if}
end;

procedure TSvPackForm.LoadBtnClick(Sender: TObject);
var f:string;
begin
f:=Global.UTSysIni;
  if FileExists(f)
    then begin
      PackList.Clear;
      LoadServerPackages(Self.PackList.Items,f);
    end;{if}
end;

procedure TSvPackForm.SaveBtnClick(Sender: TObject);
var f:string;
begin
f:=Global.UTSysIni;
  if FileExists(f)
    then begin
      WriteServerPackages(PackList.Items,f);
    end;{if}
end;

procedure TSvPackForm.RemSelBtnClick(Sender: TObject);
var i:integer;
begin
if (PackList.Items.Count>-1) then
begin
  i:=0;
  while (PackList.SelCount>0) do
    if PackList.Selected[i] then PackList.Items.Delete(i) else i:=i+1;
end;{if} 
End;

procedure TSvPackForm.Returntomenu1Click(Sender: TObject);
begin
close;
end;

procedure TSvPackForm.About1Click(Sender: TObject);
begin
AboutBox.GetHelp(helpAbout);
end;

procedure TSvPackForm.OKBtnClick(Sender: TObject);
begin
Self.Close;
end;

procedure TSvPackForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Action:=caFree;
end;

procedure TSvPackForm.CheckListBox1Click(Sender: TObject);
var x:TModDetails;
begin
  if Checklistbox1.ItemIndex>-1 then
  begin
    if Checklistbox1.Items.Objects[Checklistbox1.ItemIndex] is TModDetails
    then begin
    x:=TModDetails(Checklistbox1.Items.Objects[Checklistbox1.ItemIndex]);
    ModTitleLabel.Caption:=x.Name;
    DescriptionMemo.Lines.Text:=x.Description;
    AuthorLabel.Caption:=x.Author;
    EmailLabel.Caption:=x.Email;
    WWWLabel.Caption:=x.WWW;
    OtherContactLabel.Caption:=x.OtherContact;
    Listbox1.Items.Text:=x.ServerPackages.Text;
    if x.DatafileCompilerName=''
    then ThisDatafileByLabel.Caption:=''
    else ThisDatafileByLabel.Caption:='This datafile compiled by: '+x.DatafileCompilerName;
    if x.IsInstalled
      then begin StatusLabel.Caption:='Installed'; StatusLabel.Font.Color:=clBlack; end
      else begin StatusLabel.Caption:='Not installed'; StatusLabel.Font.Color:=clMaroon; end;
    EditDatafileBtn.Visible:=(x.UtscDatafile<>'');
    InDataStoreLabel.Visible:=NOT EditDatafileBtn.Visible;
    end
    else begin
    ModTitleLabel.Caption:='[Error loading details!]';
    DescriptionMemo.Lines.Text:='';
    AuthorLabel.Caption:='';
    EmailLabel.Caption:='';
    WWWLabel.Caption:='';
    OtherContactLabel.Caption:='';
    Listbox1.Items.Text:='';
    ThisDatafileByLabel.Caption:='';
    StatusLabel.Caption:='';
    EditDatafileBtn.Visible:=FALSE;
    InDataStoreLabel.Visible:=FALSE;
    end;
  end;
end;

procedure TSvPackForm.CheckListBox1ClickCheck(Sender: TObject);
var i,c:integer;
begin
c:=0;
if Checklistbox1.Items.Count>0 then
  for i:=0 to Checklistbox1.Items.Count-1 do
    if CheckListBox1.Checked[i] then
      inc(c);
AddTickedModsBtn.Caption:='Add '+IntToStr(c)+' ticked mods';
AddTickedModsBtn.Enabled:=(c>0);
end;



procedure TSvPackForm.UpdateChecklist(Sender: TObject);
var i:integer;  s:string;
begin
Checklistbox1.Clear;
if MasterModsList.Count>0 then
for i:=0 to MasterModsList.Count-1 do
  begin
    if ShowHeaderCB.Checked then
      s:='['+MasterModsList.Mods[i].TypeHeader+']: '+MasterModsList.Mods[i].Name
      else s:=MasterModsList.Mods[i].Name;
    if MasterModsList.Mods[i].IsInstalled OR (NOT OnlyExistingCB.Checked) then
      Checklistbox1.Items.AddObject(s,MasterModsList.Mods[i]);
  end;
Checklistbox1clickcheck(sender);
end;

procedure TSvPackForm.FormShow(Sender: TObject);
begin
Left:=0;
Top:=0;
LoadBtnClick(Self);

UpdateChecklist(Sender);
ModTitleLabel.Caption:='';
DescriptionMemo.Lines.Text:='';
AuthorLabel.Caption:='';
Emaillabel.Caption:='';
WWWlabel.Caption:='';
OtherContactLabel.Caption:='';
Listbox1.Items.Text:='';
ThisDatafileByLabel.Caption:='';
StatusLabel.Caption:='';
EditDatafileBtn.Visible:=FALSE;
InDataStoreLabel.Visible:=FALSE;
if Checklistbox1.Items.Count>0 then Checklistbox1.ItemIndex:=0
  else Checklistbox1.ItemIndex:=-1;
Checklistbox1Click(Self);
end;

procedure TSvPackForm.EditDatafileBtnClick(Sender: TObject);
var DatafileWizard:TDatafileWizard;
Begin
  {Edit this datafile}
  if (CheckListBox1.ItemIndex>-1) then
  if (Checklistbox1.Items.Objects[Checklistbox1.ItemIndex] is TModDetails)
  then
  begin
    if TModDetails(Checklistbox1.Items.Objects[Checklistbox1.ItemIndex])
        .UtscDatafile=''
      then ShowMessage('This mod is part of the main datafile UTSC210.DAT and '+
                       'can''t be edited. If you are this mod''s author and want '+
                       'to update it, or have spotted some incorrect information, '+
                       'please contact Psychic_313 with further details.')
    else begin
    DatafileWizard:=TDatafileWizard.Create(Application);
    DatafileWizard.LoadExisting(
       TModDetails(Checklistbox1.Items.Objects[Checklistbox1.ItemIndex])
       .UtscDatafile
       );
    end;
   { Knowledge.LoadMasterList;
  MainMenuForm.InformChangedKnowledge;}
  end;
End;

procedure TSvPackForm.CreateAnotherDatafileBtnClick(Sender: TObject);
var DatafileWizard:TDatafileWizard;
begin
  DatafileWizard:=TDatafileWizard.Create(Application);
  {New datafile}
  DatafileWizard.CreateNew;
  {Knowledge.LoadMasterList;
  MainMenuForm.InformChangedKnowledge;}
end;

procedure TSvPackForm.AddTickedModsBtnClick(Sender: TObject);
var i,j:integer;
begin
{add from browser}
if CheckListBox1.Items.Count>0 then
  for i:=0 to Checklistbox1.Items.count-1 do
    if Checklistbox1.Checked[i] then
      if TModDetails(CheckListBox1.Items.Objects[i]).ServerPackages.Count>0 then
        for j:=0 to TModDetails(CheckListBox1.Items.Objects[i]).ServerPackages.Count-1 do
          begin
            AddPack(TModDetails(CheckListBox1.Items.Objects[i]).ServerPackages[j]);
          end;
end;

procedure TSvPackForm.ServerPackagesEditor1Click(Sender: TObject);
begin
AboutBox.GetHelp(helpSPs);
end;

procedure TSvPackForm.Contents1Click(Sender: TObject);
begin
AboutBox.GetHelp(helpContents);
end;

procedure TSvPackForm.ClearListBtnClick(Sender: TObject);
begin
if MessageDlg('Clear server packages list?',mtConfirmation,[mbYes,mbNo],0)
 = mrYes then Packlist.Clear;
end;

procedure TSvPackForm.FormDestroy(Sender: TObject);
begin
  MainMenuForm.SvPackOpen:=FALSE;
end;

procedure TSvPackForm.FormResize(Sender: TObject);
begin
  {implementation of Align=alClient seems buggy, so I'll make my own:}
  {Implement minimum size}
  if Width<640 then Width:=640;
  {Implement resizing of left side}
  ServerPackagesPanel.Width:=ClientWidth-RightSideScrollbox.Width;
  ServerPackagesPanel.Height:=ClientHeight;
  RightSideScrollbox.Left:=ServerPackagesPanel.Width;
  RightSideScrollbox.Height:=ClientHeight;
end;

procedure TSvPackForm.BitBtn1Click(Sender: TObject);
var i:integer;
{- Nested function}
{|}   function MeetsCriteria(key:string):boolean;
{|}   begin
{|}     case FilterForm.TextFilterMethodComboBox.ItemIndex of
{|}       0: Result:=(UpperCase(key)=UpperCase(FilterForm.TextFilterEdit.text));              {is}
{|}       2: Result:=(Pos(UpperCase(FilterForm.TextFilterEdit.text),UpperCase(key))=0);  {not include}
{|}       3: Result:=StartsWith(UpperCase(key),UpperCase(FilterForm.TextFilterEdit.text));    {starts with}
{|}       else
{|}         Result:=(Pos(UpperCase(FilterForm.TextFilterEdit.text),UpperCase(key))<>0);  {include (default)}
{|}     end;{case}
{|}   end;{sub-fn}
{- end of nested function}
Begin
if FilterForm.ShowModal=mrOK then
  if (PackList.Items.Count>0) then
    for i:=PackList.Items.Count-1 downto 0 do
      if MeetsCriteria(PackList.Items[i])
        then PackList.Items.Delete(i);
End;

END.
