{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit VoiceINTLoader;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UTSharedUtils1,TBotVoiceDefine, StdCtrls, Buttons;

type
  TVoiceIntLoaderForm = class(TForm)
    Label2: TLabel;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    OpenDialog1: TOpenDialog;
    function LoadVoicesFromIntFile(IntFile:string):TBotVoiceList;
  function LoadVoices:TBotVoiceList;
  procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    StuffToReturn:TBotVoiceList;
  end;

var
  VoiceIntLoaderForm: TVoiceIntLoaderForm;

implementation

uses IntLoaderUtils, UTServerConfigGlobal;

{$R *.DFM}

function TVoiceIntLoaderForm.LoadVoicesFromIntFile(IntFile:string):TBotVoiceList;
var
{  UFile:string;  }
  Buffer,Decoder:TStringList;
  i:integer;
  s:string;
  Voice:TBotVoice;
(*  PlayersTemp,BotsTemp:TBotModelList;*)
Begin
{What to expect in a voice's INT:
---
[Public]
Object=(Name=u4edevilvoice3.u4edevilvoice,Class=Class,MetaClass=BotPack.VoiceMale,Description="U4E Devil Voice")
---
}
Result:=TBotVoiceList.Create;
Buffer:=TStringList.Create;
Decoder:=TStringList.Create;
try
  Buffer.LoadFromFile(IntFile);
  if Buffer.Count>0 then for i:=0 to Buffer.Count-1 do
  if StartsWith(UpperCase(Buffer[i]),'OBJECT=(') then
    begin
      Decoder.Text:=IntObjectToTSText(Copy(Buffer[i],9,length(Buffer[i])-9));
      s:=NonCaseSensitiveValues(Decoder,'MetaClass');
      if TextEqu(s,'Botpack.VoiceMale') then begin
        Voice:=TBotVoice.Create;
        Voice.Desc:=NonCaseSensitiveValues(Decoder,'Description');
        Voice.VoiceClass:=NonCaseSensitiveValues(Decoder,'Name');
        Voice.VoiceType:=1;
        Self.Memo1.Lines.Append('Found a male voice, class is '
                                         +Voice.VoiceClass
                                         +', description is "'
                                         +Voice.Desc+'"');
        Result.Append(Voice);
      end{if}
      else if TextEqu(s,'Botpack.VoiceBoss') then begin
        Voice:=TBotVoice.Create;
        Voice.Desc:=NonCaseSensitiveValues(Decoder,'Description');
        Voice.VoiceClass:=NonCaseSensitiveValues(Decoder,'Name');
        Voice.VoiceType:=2;
        Self.Memo1.Lines.Append('Found a Boss voice, class is '
                                         +Voice.VoiceClass
                                         +', description is "'
                                         +Voice.Desc+'"');
        Result.Append(Voice);
      end{if}
      else if TextEqu(s,'Botpack.VoiceFemale') then begin
        Voice:=TBotVoice.Create;
        Voice.Desc:=NonCaseSensitiveValues(Decoder,'Description');
        Voice.VoiceClass:=NonCaseSensitiveValues(Decoder,'Name');
        Voice.VoiceType:=0;
        Self.Memo1.Lines.Append('Found a female voice, class is '
                                         +Voice.VoiceClass
                                         +', description is "'
                                         +Voice.Desc+'"');
        Result.Append(Voice);
      end;{if}
    end;{if}
finally
  Decoder.Free;
  Buffer.Free;
end;{try}
End;

function TVoiceIntLoaderForm.LoadVoices:TBotVoiceList;
Begin
  Self.Memo1.Clear;
  StuffToReturn.Clear;
  Self.BitBtn3.Enabled:=FALSE;
  if Self.ShowModal=mrOK then begin
    Result:=StuffToReturn.Clone;
  end
  else
    Result:=TBotVoiceList.Create;
End;

procedure TVoiceIntLoaderForm.BitBtn1Click(Sender: TObject);
begin
  OpenDialog1.InitialDir:=global.UTBase+'\system';
  Self.Memo1.Clear;
  Self.BitBtn3.Enabled:=FALSE;
  if OpenDialog1.Execute then
    begin
      StuffToReturn.Free;
      StuffToReturn:=LoadVoicesFromIntFile(OpenDialog1.Filename);
      BitBtn3.Enabled:=TRUE;
    end;
end;



procedure TVoiceIntLoaderForm.FormCreate(Sender: TObject);
begin
StuffToReturn:=TBotVoiceList.Create;

end;

procedure TVoiceIntLoaderForm.FormDestroy(Sender: TObject);
begin
StuffToReturn.Free;

end;

end.

